package de.intevation.flys.client.server;

import org.w3c.dom.Document;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;

import de.intevation.artifacts.common.utils.ClientProtocolUtils;

import de.intevation.artifacts.httpclient.exceptions.ConnectionException;
import de.intevation.artifacts.httpclient.http.HttpClient;
import de.intevation.artifacts.httpclient.http.HttpClientImpl;
import de.intevation.artifacts.httpclient.http.response.DocumentResponseHandler;

import de.intevation.flys.client.shared.exceptions.ServerException;
import de.intevation.flys.client.shared.model.Artifact;
import de.intevation.flys.client.client.services.DescribeArtifactService;


/**
 * This interface provides artifact specific operation DESCRIBE.
 *
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public class DescribeArtifactServiceImpl
extends      RemoteServiceServlet
implements   DescribeArtifactService
{
    public static final String ERROR_DESCRIBE_ARTIFACT =
        "error_describe_artifact";


    public Artifact describe(String url, String locale, Artifact artifact)
    throws ServerException
    {
        System.out.println("DescribeArtifactServiceImpl.describe");

        Document describe = ClientProtocolUtils.newDescribeDocument(
            artifact.getUuid(),
            artifact.getHash(),
            true);

        HttpClient client = new HttpClientImpl(url, locale);

        try {
            System.out.println("Start Http request now.");

            Document description = (Document) client.describe(
                new de.intevation.artifacts.httpclient.objects.Artifact(
                    artifact.getUuid(),
                    artifact.getHash()),
                describe,
                new DocumentResponseHandler());

            if (description != null) {
                System.out.println("Finished Http request sucessfully!");

                return (Artifact) new FLYSArtifactCreator().create(description);
            }
        }
        catch (ConnectionException ce) {
            ce.printStackTrace();
        }

        throw new ServerException(ERROR_DESCRIBE_ARTIFACT);
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
